#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define dim 15


//lca con stringhe (senza spazi, max 15 caratteri), assumendo x e y presenti nell'albero

struct albero{ char nome[dim]; struct albero *left; struct albero *right;  };
typedef struct albero tree;

tree* add(tree *t, char *s); //aggiunge un nodo contenente s a t
char* lcas(tree *t, char *x, char *y);//restituisce il lowest common ancestor tra x e y
void stampa(tree *t);



int main()
{
int k,n;
char s[dim],x[dim],y[dim];
tree *t;
t=malloc(sizeof(tree));
t=NULL;
scanf("%d", &n); //num di elementi da inserire nell'albero
for(k=0; k<n;k++)
{scanf("%s", s); t=add(t,s);  }

printf("\n\n");
stampa(t);
printf("\n\n");
scanf("%s", x);
scanf("%s", y);
printf("\n%s\n", lcas(t,x,y));

return 0;
}


tree* add(tree *t, char *s)
{
if (t==NULL) { t=malloc(sizeof(tree)); strcpy(t->nome,s); t->left=NULL; t->right=NULL; return t; }
else if(strcmp(s,t->nome)>=0) {t->right=add(t->right,s); return t;  }
else { t->left=add(t->left,s); return t; }
}



char* lcas(tree *t, char *x, char *y)
{ 
char min[dim], max[dim];
if(t!=NULL)
 { if(strcmp(x,y)==0) return x; //sono uguali
 else //x e y sono diversi
 {
    if(strcmp(x,y)>0) { strcpy(max,x); strcpy(min,y); }
    else {strcpy(max,y); strcpy(min,x);}

if(strcmp(min,t->nome)<0 && strcmp(max,t->nome)>=0) //sono su due rami distinti dell'albero
 {return t->nome;}
else if(strcmp(min,t->nome)>=0) // entrambi sul ramo *right
{ return lcas(t->right,x,y);  }

else {return lcas(t->left,x,y);}
     } 

 }

}

void stampa(tree *t)
{ if(t!=NULL) {printf("\n%s\n", t->nome); stampa(t->right); stampa(t->left); }  }

