#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define dim 100

//N coppie chiave e valore. le N chiavi sono stringhe di al più 100 caratteri per le quali si fa un albero di ricerca non bilanciato i valori sono int positivi. prende in input una stringa s che è presente nell'albero. u nodo dell'albero avente chiave s. albero secondo le stringhe


struct albero{ char chiave[dim]; int valore; struct albero *left; struct albero *right; };
typedef struct albero tree;

tree* add(tree *t, char *s, int n); //aggiunge un nodo all'albero
tree* ricerca(tree *t, char *s); //restituisce sottoalbero che parte da s
int max(tree *t); //massimo intero nell'albero t
int trovato(tree *t, int m);//restituisce 0 se m è il massimo intero presente in t e >0 altrimenti
int massimo(int a,int b);



int main()
{
int N,k,n;
char s[dim], u[dim];
tree *t;
t=malloc(sizeof(tree));
t=NULL;
scanf("%d", &N);
for(k=0;k<N;k++)
{ scanf("%s", s); scanf("%d", &n); t=add(t,s,n);  }

scanf("%s", u);
t=ricerca(t,u);
printf("\n");
printf("%d", max(t));
printf("\n");
return 0;

}

tree* add(tree *t, char *s, int n)
{
if(t==NULL)
{t=malloc(sizeof(tree)); strcpy(t->chiave, s); t->valore=n; t->left=NULL; t->right=NULL; return t; }
else if(strcmp(s,t->chiave)>=0) {t->right=add(t->right,s,n); return t; }
else {t->left=add(t->left,s,n); return t;}
}


tree* ricerca(tree *t, char *s)
{
if(t!=NULL)
 {
   if(strcmp(s,t->chiave)==0) {return t;}
  else if(strcmp(s,t->chiave)>0) {t=t->right; return ricerca(t,s);}
  else {t=t->left; return ricerca(t,s); } 
 }

}


int max(tree *t)
{  
int m;
if(t!=NULL)
 {
 m=t->valore;
 if(trovato(t,m)==0) // m è il massimo in t 
  { return m; }

 else if (trovato(t->left,m)==0) //m è più grande degli altri valori in t->left
     { t=t->right; return max(t);  }
 
 else if (trovato(t->right,m)==0) //m è più grande degli altri valori in t->right
     { t=t->left; return max(t);  }

 else //ci sono elementi più grandi di m sia in right che in left
    { return massimo(max(t->left), max(t->right));  }
 
 }
}


int trovato(tree *t, int m)
{
int k;
k=0;
if(t!=NULL)
{
  if(t->valore > m) //m non è il massimo
 { k++; return k; }

  else 
 { return trovato(t->left,m)+trovato(t->right,m); }

  
 }

}




int massimo(int a,int b)
{
if(a>=b) return a;
else return b;
}











