#include <stdio.h>
#include <stdlib.h>

struct lista{ int info;
 struct lista *next;
};

typedef struct lista Lista;

int min(Lista *l, int m); /*restituisce 1 se m è il più piccolo nella lista, 0 altrimenti*/
void stampa(Lista *l);
Lista* inserisci_in_testa(Lista *l, int m);
Lista* ordina(Lista *l, int m);/*inserisce m nella l ordinatamente*/


int main()
{
Lista *l;
int m;
scanf("%d", &m);
l=malloc(sizeof(Lista));
l->info=m;
l->next=NULL;
scanf("%d", &m);
while(m>=0)
{
l=ordina(l,m);
scanf("%d", &m);
}
stampa(l);
}


Lista* ordina(Lista *l, int m)
{
if(l!=NULL)
 {if(min(l,m)==1){l=inserisci_in_testa(l,m);}
else {l->next=ordina(l->next,m);}
}
else{l=malloc(sizeof(Lista));
l->info=m; l->next=NULL; }
return l;
}

void stampa(Lista *l)
{
if(l!=NULL)
{printf("\n%d\n", l->info);
 stampa(l->next);
}
}


Lista* inserisci_in_testa(Lista *l, int m)
{
Lista *temp=malloc(sizeof(Lista));
temp->info=m;
temp->next=l;
return temp;
}

int min(Lista *l, int m) /*restituisce 1 se m è il più piccolo nella lista, 0 altrimenti*/

{
 int trovato=1;
if(l!=NULL)
{ 
if(l->info<m)
{trovato=0;}
else{trovato=min(l->next,m);}
  }
return trovato;
}

