#include <stdio.h>
#include <stdlib.h>

struct lista{
 int info;
 struct lista *next;
 };

typedef struct lista Lista;

Lista* pulisci_lista(Lista *l);/*elimina gli elementi presenti in più di una copia*/
Lista* crea_nodo(Lista *l);/*aggiunge un nodo alla lista*/
void stampa(Lista *l);
Lista* cancella_primo(Lista *l);/*cancella il primo elemento della lista*/
int trovato(Lista *l,int m);/*restituisce 1 se m appartiene a l e 0 altrimenti*/
Lista* prima_occorrenza(Lista *l, int m);/*cancella la prima occorrenza di m in l*/
Lista* tutte_occorrenze(Lista *l, int m);/*cancella tutte le occorrenze di m in l*/



int main()
{
 int n,i;
 Lista *l;
 l=malloc(sizeof(Lista));
 l=NULL;
 printf("\ninserisci il numero degli elementi\n");
 scanf("%d",&n);
for(i=0;i<n;i++)
 {
 l=crea_nodo(l);
 }
l=pulisci_lista(l);
stampa(l);
return 0;
}




Lista* tutte_occorrenze(Lista *l, int m)
{
 if(l!=NULL)
 {while(trovato(l,m)==1) l=prima_occorrenza(l,m);}
return l;
 }

Lista* prima_occorrenza(Lista *l, int m)
{
if(l!=NULL)
{if((l->info)==m) l=cancella_primo(l);
 else l->next=prima_occorrenza(l->next,m);
return l;
 }
}

int trovato(Lista *l, int m)
{
int found=0;
if(l!=NULL)
{
 if(l->info==m)
{found=1; return found; }
else return trovato(l->next,m);
 }
}


Lista* cancella_primo(Lista *l)
{
 Lista *temp;
 if(l!=NULL)
{
 temp=malloc(sizeof(Lista));
 temp=l;
 l=l->next;
 free(temp);
 return l;
 }
 }

void stampa(Lista *l)
{
if(l!=NULL)
 {
 printf("\n%d\n", l->info);
 stampa(l->next);
 }
}

Lista* crea_nodo(Lista *l)
{
if(l==NULL)
{l=malloc(sizeof(Lista));
 printf("\n\ninserisci un elemento\n\n");
 scanf("%d", &(l->info));
 l->next=NULL;
 }
else {l->next=crea_nodo(l->next);}
return l;
 }

Lista* pulisci_lista(Lista *l)
{
if(l!=NULL)
{if(trovato(l->next,l->info)==1) 
 {
   l->next=tutte_occorrenze(l->next,l->info);
   l->next=pulisci_lista(l->next);
  }
else l->next=pulisci_lista(l->next);

return l;
 }

 }


