#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define dim 15

//Ordinamento alfabetico di stringhe in numero arbitrario con sentinella

struct s{ char nome[dim]; };

typedef struct s T;

struct Coda{
 char nome[dim];
 struct Coda *next;
};

typedef struct Coda coda;




void stampa(coda *q);	
coda* inserisci_in_testa(coda *l, char *s);
int min(coda *q, char *s);//restituisce 1 se s è il minimo di q e 0 altrimenti
coda* ordina(coda *l,char *m); //inserzione ordinata


int main()
{
coda *q;
int k,n=0,b=1;
int e=1; //sentinella
T *v;
v=(T*)malloc(sizeof(T));
while (e!=0)
 {
 n++;
 v=realloc(v,(n+1)*sizeof(T));
 fgets(v[n].nome,dim,stdin);
 b++;
 scanf("%d", &e);
 }
printf("\n\n\n");

q=(coda*)malloc(sizeof(coda)); //creo una lista a partire dall'array dato
q=NULL;
for(k=1;k<=b+1;k++)
{
q=ordina(q,v[k].nome);
 }
stampa(q);


}



coda* inserisci_in_testa(coda *l, char *s)
 {
 coda *temp;
 temp=malloc(sizeof(coda));
 strcpy(temp->nome,s);
 temp->next=l;
return temp;
 }



int min(coda *q, char *s)
{
int m=1;
if(q!=NULL)
{
 if (strcmp(s, q->nome)>0) //q->nome è più piccolo in ordine alfabetico rispetto a s
 {
  m=0;
 }
else m=min(q->next,s);
 }
return m;
}


coda* ordina(coda *l,char *m) //inserzione ordinata
{
if(l!=NULL)
 {
 if(min(l,m)==1) l=inserisci_in_testa(l,m);
 else l->next=ordina(l->next,m);
  }
else l=inserisci_in_testa(l,m);
return l;
 }



void stampa(coda *q)
{
  while(q!=NULL)
{printf("%s\n", q->nome);
 q=q->next; }

}
